viTotalStateOutput = {};

function viTotalStateOutput:load(slotTable)	
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;
	local color = "txtOutputTitle";
	local iconColor = "darkGray";
	--title
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];			
	isLineTable.notScroll = true;
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].slotColor = color;					
	isLineTable.txt[1].txt = g_i18n:getText("ui_garageOverview").. " (".. 	g_i18n:getText("ui_statistics").. ")";			
	isLineTable.txt[1].alignment = 2;
	isLineTable.txt[1].icon = {before={},after={},behindTxt={}};
	isLineTable.txt[1].icon.behindTxt[1] = {name="priceTrendOnOff", color="ls22", modName="MultiOverlayV4", groupName="slotoutput"};
	isLineTable.txt[1].callback = viTotalStateOutput.clickTitle;	
	--title
	if #viTotalState.values.vehicles > 0 then
		local typNumber = 1;
		local lastTypName = "";
		for a=1, #viTotalState.values.vehicles do			
			local vehicle = viTotalState.values.vehicles[a];			
			local width = {30};
			local maxColumn = 0;
			local foundColumn = 1;
			function setWidthColumn()				
				for k, v in pairs (viTotalState.values.view) do
					if k ~= "all" then foundColumn = foundColumn+1;end;
					if v == true and k ~= "all" then 
						maxColumn = maxColumn+1;							
					end;
				end;				
				if maxColumn > 0 then width[2] = (99.5-width[1])/maxColumn;else width[1] = 100;end;
				if viTotalState.values.view.all then width[2] = (99.5-width[1])/(foundColumn-1);end;
				maxColumn = maxColumn+1;
			end;
			setWidthColumn();			
			if a == 1 then
				--title total--				
				color = "txtOutputTitle"
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.notScroll = true;
				
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;				
				isLineTable.txt[1].txt = " ";						
				isLineTable.txt[1].icon = {before={},after={},behindTxt={}};
				isLineTable.txt[1].width = 30;
				if viTotalState.values.view.all or maxColumn == foundColumn then 
					color = "green";
				elseif maxColumn ~= foundColumn then
					color = "yellow";
				else 
					color = "darkGray";
				end;				
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="viewSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"all"}, infoTxt="View All On/Off"};
				--viewTyp--
				if viTotalState.values.view.all or viTotalState.values.viewTyp.isWeight then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="weightSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewTyp}, ownTable={"isWeight"}, infoTxt="View Typ Weight"};
				if viTotalState.values.view.all or viTotalState.values.viewTyp.canControlled then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="controlledSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewTyp}, ownTable={"canControlled"}, infoTxt="View Typ can Controlled"};
				--viewTyp--
				--icon separator--
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="buttonSeparatorVertical", color="ls22", settingButton=true};
				--icon separator--
				if viTotalState.values.view.all or viTotalState.values.view.age then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="ageSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"age"}, infoTxt="View Vehicle Age"};
				if viTotalState.values.view.all or viTotalState.values.view.operatingTime then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="operatingTimeSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"operatingTime"}, infoTxt="View Vehicle Operating Time"};
				if viTotalState.values.view.all or viTotalState.values.view.repairPrice then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="outputSetting", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"repairPrice"}, infoTxt="View Vehicle RepairPrice"};
				if viTotalState.values.view.all or viTotalState.values.view.fuel then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="fuelSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"fuel"}, infoTxt="View Vehicle Fuel"};
				if viTotalState.values.view.all or viTotalState.values.view.leasingCost then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="leasingSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"leasingCost"}, infoTxt="View Vehicle Leasing Cost"};
				if viTotalState.values.view.all or viTotalState.values.view.sellPrice then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="sellSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"sellPrice"}, infoTxt="View Vehicle Selling Price"};
				if viTotalState.values.view.all or viTotalState.values.view.buyPrice then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="buySlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"buyPrice"}, infoTxt="View Vehicle Buying Price"};
				if viTotalState.values.view.all or viTotalState.values.view.maxSpeed then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="speedSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"maxSpeed"}, infoTxt="View Vehicle Max Speed"};
				if viTotalState.values.view.all or viTotalState.values.view.ps then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="engineSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"ps"}, infoTxt="View Vehicle Engine"};
				if viTotalState.values.view.all or viTotalState.values.view.mass then color = "green";else color = "darkGray";end;
				isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="massSlotIcon", color=color, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewState}, ownTable={"mass"}, infoTxt="View Vehicle Mass"};
				
					
				isLineTable.txt[2] = {};
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = g_i18n:getText("ui_garageOwned").. ": ".. tostring(#viTotalState.values.vehicles);
				isLineTable.txt[2].slotColor = color;
				isLineTable.txt[2].alignment = 2;
				isLineTable.txt[3] = {};
				isLineTable.txt[3].bold = true;				
				isLineTable.txt[3].txt = g_i18n:getText("ui_buyPrices").. ": ".. tostring(vehicle.totalBuyPrice); --ui_total = Gesamt
				isLineTable.txt[3].slotColor = color;
				isLineTable.txt[3].alignment = 2;
				isLineTable.txt[4] = {};
				isLineTable.txt[4].bold = true;
				isLineTable.txt[4].txt = g_i18n:getText("ui_sellPrices").. ": "..tostring(vehicle.totalSellPrice);
				isLineTable.txt[4].slotColor = color;
				isLineTable.txt[4].alignment = 2;
				isLineTable.txt[5] = {};
				isLineTable.txt[5].bold = true;
				isLineTable.txt[5].txt = g_i18n:getText("button_repair").. "/".. g_i18n:getText("fieldJob_tally_total").. ": "..tostring(vehicle.totalRepairPrice);
				isLineTable.txt[5].slotColor = color;
				isLineTable.txt[5].alignment = 2;
				--title total--
				---seperator---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.notScroll = true;
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = "----";
				isLineTable.txt[2] = {};				
				isLineTable.txt[2].txt = "";				
				isLineTable.txt[3] = {};				
				isLineTable.txt[3].txt = "";				
				isLineTable.txt[4] = {};
				isLineTable.txt[4].slotColor = "txtOutputTitle";
				isLineTable.txt[4].bold = true;
				isLineTable.txt[4].txt = "----";
				isLineTable.txt[4].alignment = 3;
				---seperator---
				--title Icons--				
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.notScroll = true;
				isLineTable.txt = {};				
				isLineTable.txt[1] = {};
				local moreTxt = "fullName";
				if viTotalState.values.sortBy.what == "typeDescName" or viTotalState.values.sortBy.what == "viCategoryName" then moreTxt = viTotalState.values.sortBy.what;end;
				isLineTable.txt[1].txt = " Name: ".. tostring(moreTxt);
				isLineTable.txt[1].width = width[1];
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].icon = {before={},after={}};
				iconColor = "ls22";
				if viTotalState.values.sortBy.what == "typeDescName" or viTotalState.values.sortBy.what == "viCategoryName" then iconColor = "yellow";end;
				isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByString", "name"}, infoTxt="Sort by Name"};
				if not VehicleInspector.seeVehicle.isOwnFarmVehicle and vehicle.foundContractorVehicle then
					iconColor = "ls22";
					if viTotalState.values.sortBy.what == "ownerFarmId" then iconColor = "yellow";end;
					isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="contractorSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByBol", "ownerFarmId", "bol"}, infoTxt="Sort by Contractor Vehicle"};
				end;
				if viTotalState.values.view.all or viTotalState.values.viewTyp.canControlled then
					if vehicle.foundControlledVehicle then
						iconColor = "ls22";
						if viTotalState.values.sortBy.what == "canControlled" then iconColor = "yellow";end;
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="controlledSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByBol", "canControlled", "bol"}, infoTxt="Sort by can Controlled Vehicle"};
					end;
					if vehicle.foundGpsVehicle then
						iconColor = "ls22";
						if viTotalState.values.sortBy.what == "hashGps" then iconColor = "yellow";end;
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="gpsSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByBol", "hashGps", "bol"}, infoTxt="Sort by GPS Vehicle"};
					end;
					if vehicle.foundParkingVehicle then
						iconColor = "ls22";
						if viTotalState.values.sortBy.what == "isParking" then iconColor = "yellow";end;
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="parkingSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByBol", "isParking", "bol"}, infoTxt="Sort by Parking Vehicle"};
					end;
				end;
				function setAgeIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = ""; --g_i18n:getText("infohud_age"):upper();
					--isLineTable.txt[#isLineTable.txt].color = "ls22";
					--isLineTable.txt[#isLineTable.txt].bold = true;
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3 ;					
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "age" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="ageSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "age", "high"}, infoTxt="Sort by Age"};
				end;
				function setOperatingTimeIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = ""; --g_i18n:getText("infohud_age"):upper();
					--isLineTable.txt[#isLineTable.txt].color = "ls22";
					--isLineTable.txt[#isLineTable.txt].bold = true;
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3 ;					
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "operatingTime" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="operatingTimeSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "operatingTime", "high"}, infoTxt="Sort by Operating Time"};
				end;
				function setFuelIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3 ;					
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					local ownTable = {"sortByInt", "fuel", "high"};local infoTxt = "Sort by Fuel";
					if viTotalState.values.viewOther.refuel then ownTable = {"sortByInt", "refuel", "high"};infoTxt = "Sort by Refuel";end;
										
					if viTotalState.values.sortBy.what == "fuel" or viTotalState.values.sortBy.what == "refuel" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="fuelSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable=ownTable, infoTxt=infoTxt};
					iconColor = "darkGray";
					if viTotalState.values.viewOther.refuel then iconColor = "green";end;
					isLineTable.txt[#isLineTable.txt].icon.after[2] = {name="refuelSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewOther}, ownTable={"sortByInt", "refuel", "high"}, infoTxt="View Max Refuel"};
				end;
				function setLeasingIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3 ;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "leasingCost" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="leasingSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "leasingCost", "high"}, infoTxt="Sort by Leasing"};
				end;
				function setSellPriceIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;					
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "sellPrice" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="sellSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "sellPrice", "high"}, infoTxt="Sort by SellPrice"};
				end;
				function setBuyPriceIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "buyPrice" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="buySlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "buyPrice", "high"}, infoTxt="Sort by BuyPrice"};
				end;
				function setRepairPriceIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "repairPrice" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="outputSetting", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "repairPrice", "high"}, infoTxt="Sort by RepairPrice"};
				end;
				function setMaxSpeedIcon()				
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					local ownTable = {"sortByInt", "maxSpeed", "high"};local infoTxt = "Sort by Max Speed";
					if viTotalState.values.sortBy.what == "maxSpeed" or viTotalState.values.sortBy.what == "maxWorkingSpeed" then iconColor = "yellow";end;
					if viTotalState.values.viewOther.maxWorkingSpeed then ownTable = {"sortByInt", "maxWorkingSpeed", "high"};infoTxt = "Sort by Max Working Speed";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="speedSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable=ownTable, infoTxt=infoTxt};
					iconColor = "darkGray";
					if viTotalState.values.viewOther.maxWorkingSpeed then iconColor = "green";end;
					isLineTable.txt[#isLineTable.txt].icon.after[2] = {name="workingSpeedSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewOther}, ownTable={"sortByInt", "maxWorkingSpeed", "high"}, infoTxt="View Max Working Speed"};
				end;
				function setPsIcon()
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					local ownTable = {"sortByInt", "ps", "high"};local infoTxt = "Sort by Max PS";
					if viTotalState.values.sortBy.what == "ps" or viTotalState.values.sortBy.what == "updatePs" then iconColor = "yellow";end;
					if viTotalState.values.viewOther.updatePs then ownTable = {"sortByInt", "updatePs", "high"};infoTxt = "Sort by Update PS";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="engineSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable=ownTable, infoTxt=infoTxt};
					iconColor = "darkGray";
					if viTotalState.values.viewOther.updatePs then iconColor = "green";end;
					isLineTable.txt[#isLineTable.txt].icon.after[2] = {name="engineUpdateSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickViewOther}, ownTable={"sortByInt", "updatePs", "high"}, infoTxt="View Update PS"};
				end;
				function setMassIcon()
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = "";
					isLineTable.txt[#isLineTable.txt].width = width[2];
					--isLineTable.txt[#isLineTable.txt].alignment = 3;
					iconColor = "ls22";
					isLineTable.txt[#isLineTable.txt].icon = {before={},after={},behindTxt={}};
					if viTotalState.values.sortBy.what == "ps" then iconColor = "yellow";end;
					isLineTable.txt[#isLineTable.txt].icon.after[1] = {name="massSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickSortBy}, ownTable={"sortByInt", "mass", "high"}, infoTxt="Sort by Mass"};
				end;
				--icon anzeige reihenfolge--
				if viTotalState.values.view.all or viTotalState.values.view.age then setAgeIcon(10);end;
				if viTotalState.values.view.all or viTotalState.values.view.operatingTime then setOperatingTimeIcon(10);end;
				if viTotalState.values.view.all or viTotalState.values.view.repairPrice then setRepairPriceIcon(5);end;
				if viTotalState.values.view.all or viTotalState.values.view.fuel then setFuelIcon(5);end;
				if viTotalState.values.view.all or viTotalState.values.view.leasingCost then setLeasingIcon(10);end;
				if viTotalState.values.view.all or viTotalState.values.view.sellPrice then setSellPriceIcon(10);end;
				if viTotalState.values.view.all or viTotalState.values.view.buyPrice then setBuyPriceIcon(10);end;
				if viTotalState.values.view.all or viTotalState.values.view.maxSpeed then setMaxSpeedIcon(5);end;
				if viTotalState.values.view.all or viTotalState.values.view.ps then setPsIcon(5);end;
				if viTotalState.values.view.all or viTotalState.values.view.mass then setMassIcon(5);end;
				--txt anzeige reihenfolge--
				--title Icons--			
			else
				function canViewTyp()
					if viTotalState.values.view.all then return true;end;
					for typ, view in pairs(viTotalState.values.viewTyp) do
						if not view and vehicle[typ] then return false;end;						
					end;
					return true;
				end;
				if canViewTyp() then
					function setAgeTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.age ~= nil and vehicle.age > 0 then 
							local ageTxt = "";
							if vehicle.age > 1 then ageTxt=g_i18n:getText("ui_months");else ageTxt=g_i18n:getText("ui_month");end;
							isLineTable.txt[#isLineTable.txt].txt = tostring(vehicle.age).. " ".. ageTxt;
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setOperatingTimeTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.operatingTime ~= nil and vehicle.operatingTime > 0 then						
							isLineTable.txt[#isLineTable.txt].txt = tostring(vehicle.operatingTimeVI).. " h";
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setFuelTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						isLineTable.txt[#isLineTable.txt].color = color;					
						local refuelTxt = "";
						local fuel = -1;
						if viTotalState.values.viewOther.refuel then
							if vehicle.refuel ~= nil and vehicle.refuel >= 1 and vehicle.refuel ~= vehicle.fuel then
								fuel = vehicle.refuel;
								refuelTxt = "-";														
							end;
						elseif not viTotalState.values.viewOther.refuel and vehicle.fuel ~= nil and vehicle.fuel >= 0 then
							fuel = vehicle.fuel;												
						end;
						if fuel >= 0 then
							local fuelTxt = tostring(refuelTxt).. string.format(g_i18n:getText("shop_fuelValue"), fuel, g_i18n:getText("unit_literShort"));
							if vehicle.fullName ~= nil then
								if vehicle.fuelName == "ELECTRICCHARGE" then fuelTxt = tostring(refuelTxt).. string.format(g_i18n:getText("shop_fuelValue"), fuel, g_i18n:getText("unit_kw"));end;
								if vehicle.fuelName == "METHANE" then fuelTxt = tostring(refuelTxt).. string.format(g_i18n:getText("shop_fuelValue"), fuel, g_i18n:getText("unit_kg"));end;
								--if vehicle.fullName == "DEF" then fuelTxt = tostring(refuelTxt).. string.format(g_i18n:getText("shop_fuelDefValue"), fuel, g_i18n:getText("unit_literShort"), vehicle.fuelDef, g_i18n:getText("unit_literShort"), g_i18n:getText("fillType_def_short"));end;
							end;
							if vehicle.fuel < (vehicle.fuelCapacity/50) then isLineTable.txt[#isLineTable.txt].color = "yellow";end; -- < 50% color warning
							if vehicle.fuel < (vehicle.fuelCapacity/10) then isLineTable.txt[#isLineTable.txt].color = "orange";end; -- < 10% color warning
							isLineTable.txt[#isLineTable.txt].txt = tostring(fuelTxt);	
						else
							isLineTable.txt[#isLineTable.txt].txt = "-"; --unknown typ
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setLeasingTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.isLeasing then 
							isLineTable.txt[#isLineTable.txt].txt = g_i18n:formatMoney(Utils.getNoNil(vehicle.leasingCost, 0), 0, true, false); --g_i18n:getText("button_yes", "Yes");
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";						
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setSellPriceTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.sellPrice ~= nil and vehicle.sellPrice > 0 then 
							isLineTable.txt[#isLineTable.txt].txt = g_i18n:formatMoney(Utils.getNoNil(vehicle.sellPrice, 0), 0, true, false);
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";						
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setBuyPriceTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.buyPrice ~= nil and vehicle.buyPrice > 0 then 
							isLineTable.txt[#isLineTable.txt].txt = g_i18n:formatMoney(Utils.getNoNil(vehicle.buyPrice, 0), 0, true, false); 				
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";						
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setRepairPriceTxt()					
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.repairPrice ~= nil and vehicle.repairPrice >= 1 then 
							isLineTable.txt[#isLineTable.txt].txt = g_i18n:formatMoney(Utils.getNoNil(math.max(vehicle.repairPrice, 0.5), 0), 0, true, false); 	
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setMaxSpeedTxt()					
						--string.format(g_i18n:getText("shop_maxSpeed"), string.format("%1d", g_i18n:getSpeed(maxSpeed)), g_i18n:getSpeedMeasuringUnit())
						isLineTable.txt[#isLineTable.txt+1] = {};					
						isLineTable.txt[#isLineTable.txt].color = color;
						if not viTotalState.values.viewOther.maxWorkingSpeed then
							if vehicle.hashEngine and vehicle.maxSpeed ~= nil and vehicle.maxSpeed >= 1 then
								isLineTable.txt[#isLineTable.txt].txt = string.format(g_i18n:getText("shop_maxSpeed"), string.format("%1d", g_i18n:getSpeed(vehicle.maxSpeed)), g_i18n:getSpeedMeasuringUnit());
							else
								isLineTable.txt[#isLineTable.txt].txt = "-";
							end;
						elseif viTotalState.values.viewOther.maxWorkingSpeed and vehicle.maxWorkingSpeed ~= nil and vehicle.maxWorkingSpeed > 5 then
							isLineTable.txt[#isLineTable.txt].txt = string.format(g_i18n:getText(ShopConfigScreen.L10N_SYMBOL.WORKING_SPEED), string.format("%1d", g_i18n:getSpeed(vehicle.maxWorkingSpeed)), g_i18n:getSpeedMeasuringUnit());
							if vehicle.loweredWorkingSpeed then isLineTable.txt[#isLineTable.txt].color = "yellow";end; --damage behind workingSpeed :-(
						else
							isLineTable.txt[#isLineTable.txt].txt = "-"; --unknown typ
						end;					
						isLineTable.txt[#isLineTable.txt].width = width[2];										
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setPsTxt()
						isLineTable.txt[#isLineTable.txt+1] = {};					
						isLineTable.txt[#isLineTable.txt].color = color;
						if vehicle.hashEngine and not viTotalState.values.viewOther.updatePs then
							if vehicle.ps ~= nil and vehicle.ps >= 1 then 
								isLineTable.txt[#isLineTable.txt].txt = string.format(g_i18n:getText("shop_maxPowerValueSingle"), vehicle.ps); 	
							else
								isLineTable.txt[#isLineTable.txt].txt = "-";
							end;
						elseif vehicle.hashEngine and viTotalState.values.viewOther.updatePs and vehicle.canUpdatePs then
							if not g_currentMission.hl.runsTimer("2sec", true) then
								isLineTable.txt[#isLineTable.txt].txt = string.format(g_i18n:getText("shop_maxPowerValueRange"), vehicle.minPs, vehicle.maxPs);
							else
								isLineTable.txt[#isLineTable.txt].txt = "-".. string.format(g_i18n:getText("shop_maxPowerValueSingle"), vehicle.updatePs);
							end;
						else
							isLineTable.txt[#isLineTable.txt].txt = "-"; --unknown typ
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					function setMassTxt()
						isLineTable.txt[#isLineTable.txt+1] = {};					
						if vehicle.mass ~= nil and vehicle.mass >= 1 then 
							isLineTable.txt[#isLineTable.txt].txt = tostring(g_i18n:formatMass(vehicle.mass)); 	
						else
							isLineTable.txt[#isLineTable.txt].txt = "-";
						end;
						isLineTable.txt[#isLineTable.txt].width = width[2];					
						isLineTable.txt[#isLineTable.txt].color = color;					
						isLineTable.txt[#isLineTable.txt].alignment = 3;
						isLineTable.txt[#isLineTable.txt].callback = viTotalStateOutput.clickSelectVehicle;
						isLineTable.txt[#isLineTable.txt].ownTable = {vehicle.node};
					end;
					
					local nearObject = false;
					function getNearObject()
						local pPosX, pPosY, pPosZ = g_currentMission.hl.getPlayerPos(false); --player onFoot					
						if pPosX ~= nil and vehicle.steeringAxleNode ~= nil then
							local oPosX, oPosY, oPosZ = getWorldTranslation(vehicle.steeringAxleNode);
							nearObject = g_currentMission.hl.playerNearObject( {x=pPosX,y=pPosY,z=pPosZ}, {x=oPosX,y=oPosY,z=oPosZ, 4});
						else
							if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.rootNode == vehicle.node then nearObject = true;end; --player in onVehicle
						end;					
					end;
					if viTotalState.values.selectVehicle > 0 and vehicle.node == viTotalState.values.selectVehicle then
						color = "ls22";
					else
						if a%2 == 0 then color = "white";else color = "lightGreen";end;
					end;
					local iconColor = "white";
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					if viTotalState.values.sortBy.what == "typeDescName" or viTotalState.values.sortBy.what == "viCategoryName" then
						if lastTypName:len() == 0 then 
							lastTypName = vehicle[viTotalState.values.sortBy.what];
						else
							if lastTypName ~= vehicle[viTotalState.values.sortBy.what] then lastTypName = vehicle[viTotalState.values.sortBy.what];typNumber=typNumber+1;end;
						end;
					end;	
					if viTotalState.values.sortBy.what == "fullName" then				
						isLineTable.txt[1].txt = tostring(vehicle.fullName).. " (".. tostring(vehicle.typeDescName).. ")";
					elseif viTotalState.values.sortBy.what == "typeDescName" then	
						isLineTable.txt[1].txt = tostring(typNumber).. ".".. tostring(vehicle.typeDescName).. " (".. tostring(vehicle.fullName).. ")";
					elseif viTotalState.values.sortBy.what == "viCategoryName" then
						isLineTable.txt[1].txt = tostring(typNumber).. ".".. tostring(vehicle.viCategoryName).. " (".. tostring(vehicle.fullName).. " / ".. tostring(vehicle.typeDescName).. ")";
					else
						isLineTable.txt[1].txt = tostring(vehicle.fullName).. " (".. tostring(vehicle.typeDescName).. ")";
					end;
					getNearObject();				
					isLineTable.txt[1].color = color;
					if nearObject then					
						isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";isLineTable.txt[1].bold = true;
						if viTotalState.selectVehicle ~= vehicle.node then
							if not g_currentMission.hl.runsTimer("1sec", true) then
								isLineTable.txt[1].color = "yellow";
							end;
						end;
					end;				
					isLineTable.txt[1].width = width[1];
					isLineTable.txt[1].callback = viTotalStateOutput.clickSelectVehicle;
					isLineTable.txt[1].ownTable = {vehicle.node};
					if viTotalState.values.selectVehicle > 0 and viTotalState.values.selectVehicle == vehicle.node then
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;
						iconColor = "green";
						isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="teleportSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickTeleportIcon}, ownTable={vehicle.node}, infoTxt="Teleport Vehicle Position"};
						isLineTable.txt[1].txt = " ".. isLineTable.txt[1].txt;
					end;
					if vehicle.canControlled then
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;
						iconColor = color;
						if vehicle.hashEngine and vehicle.engineOn then iconColor = "yellow";end;
						if vehicle.isControlled then iconColor = "green";end;
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="controlledSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", callback={[1]=viTotalStateOutput.clickControlledIcon}, ownTable={vehicle.node}, infoTxt="Controlled Vehicle"};				
					end;
					if not VehicleInspector.seeVehicle.isOwnFarmVehicle and not vehicle.ownerFarmId then
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;
						iconColor = "ls22";
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="contractorSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", infoTxt="Contractor Vehicle"};				
					end;
					if vehicle.hashGps ~= nil and vehicle.hashGps then
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;
						iconColor = color;
						if vehicle.gpsActive then iconColor = "green";end;
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="gpsSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", infoTxt="GPS Vehicle"};
					end;
					if vehicle.isParking ~= nil and vehicle.isParking then
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;
						iconColor = "green";					
						isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="parkingSlotIcon", color=iconColor, modName="VehicleInspector", groupName="slotoutput", infoTxt="Vehicle is Parking"};
					end;
					--txt anzeige reihenfolge--
					if viTotalState.values.view.all or viTotalState.values.view.age then setAgeTxt(10);end;
					if viTotalState.values.view.all or viTotalState.values.view.operatingTime then setOperatingTimeTxt(10);end;
					if viTotalState.values.view.all or viTotalState.values.view.repairPrice then setRepairPriceTxt(5);end;
					if viTotalState.values.view.all or viTotalState.values.view.fuel then setFuelTxt(5);end;
					if viTotalState.values.view.all or viTotalState.values.view.leasingCost then setLeasingTxt(10);end;
					if viTotalState.values.view.all or viTotalState.values.view.sellPrice then setSellPriceTxt(10);end;
					if viTotalState.values.view.all or viTotalState.values.view.buyPrice then setBuyPriceTxt(10);end;
					if viTotalState.values.view.all or viTotalState.values.view.maxSpeed then setMaxSpeedTxt(5);end;
					if viTotalState.values.view.all or viTotalState.values.view.ps then setPsTxt(5);end;
					if viTotalState.values.view.all or viTotalState.values.view.mass then setMassTxt(5);end;
					--txt anzeige reihenfolge--
				end;
			end;			
		end;
		if viTotalState.values.selectVehicle > 0 and not slotTable.view[slotTable.view.isModus].isSmallView then
			local previewVehicle = g_currentMission.nodeToObject[viTotalState.values.selectVehicle];			
			if previewVehicle ~= nil then				
				local vehicleName = tostring(previewVehicle.getName(previewVehicle));
				if VehicleInspector.storeOverlays[vehicleName] ~= nil then					
					local width = (g_currentMission.multiOverlayV4.moSetGetOverlays.buttonGfxWidth1*slotTable.settingZoomOutIn)*6;
					local height = (g_currentMission.multiOverlayV4.moSetGetOverlays.buttonGfxHeight1*slotTable.settingZoomOutIn)*6;
					local groundOverlay = VehicleInspector.overlays["previewGround"];
					local overlay = VehicleInspector.storeOverlays[vehicleName];
					local posX = slotTable.posX[slotTable.view.isModus]-0.001;
					local posY = slotTable.posY[slotTable.view.isModus];					
					local slotHeight = slotTable.height[slotTable.view.isModus];
					if height <= slotHeight then 
						g_currentMission.hl.setOverlay(groundOverlay, posX-width, posY-height, width, height);
						groundOverlay:render();
						g_currentMission.hl.setOverlay(overlay, posX-width, posY-height, width, height);
						overlay:render();
						if previewVehicle.viFillCapacity ~= nil and previewVehicle.viFillCapacity > 0 then
							--respect settings for other mods (not every mod) that's why
							setTextAlignment(0);
							setTextLineBounds(0, 0);
							setTextWrapWidth(0);
							setTextColor(1, 1, 1, 1);
							setTextBold(false);
							--respect settings for other mods
							local txt = string.format(g_i18n:getText("shop_fuelValue"), previewVehicle.viFillCapacity, g_i18n:getText("unit_literShort"));
							local size = g_currentMission.hl.optiWidthSize(width-0.004, txt, 0.014);
							local txtHeight = getTextHeight(size, utf8Substr(txt, 0));
							color = g_currentMission.hl.getColor("ls22", true);
							setTextAlignment(2);
							setTextBold(true);	
							setTextColor(unpack(color));
							renderText(posX-0.002, posY-txtHeight, size-0.001, txt);
							--respect settings for other mods (not every mod) that's why
							setTextAlignment(0);
							setTextLineBounds(0, 0);
							setTextWrapWidth(0);
							setTextColor(1, 1, 1, 1);
							setTextBold(false);
							--respect settings for other mods
						end;
					end;
				end;
			end;
		end;
		--fix notScrollLines in MultiOverlayV4--
		function isNextSlotCmd()
			if #slotTable.cmd == 1 then return false;end;
			for cmd=1, #slotTable.cmd do
				if slotTable.cmd[cmd].regName == "VehicleInspector_cmd_output_viTotalState_" and slotTable.cmd[cmd+1] ~= nil then 
					--if slotTable.cmd[cmd+1].regName == "VehicleInspector_cmd_output_viTotalStateDummy_" then return true;end;
					return true;
				end;
			end;
			return false;
		end;
		local fixLines = 1;
		if not isNextSlotCmd() then
			fixLines = viTotalState.values.notScrollLines;
		end;
		function setNoScrollLinesFix()
			for a=1, fixLines do
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].txt = "";			
			end;		
		end;
		setNoScrollLinesFix();
		--fix notScrollLines in MultiOverlayV4--		
	else
		--player/farm not Vehicle--
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].slotColor = "settingAlreadyExistsCmd";					
		isLineTable.txt[1].txt = g_i18n:getText("ai_validationErrorNoVehicle").. " (".. g_i18n:getText("ui_tools")..  " / ".. g_i18n:getText("category_trailers").. " / ...)";
		--player/farm not Vehicle--
	end;
	--help icon--
	if slotTable ~= nil and slotTable.help.outputOn and lineTable.line[1] ~= nil and lineTable.line[1].txt ~= nil and lineTable.line[1].txt[1] ~= nil then		
		if lineTable.line[1].txt[1].icon == nil then lineTable.line[1].txt[1].icon = {before={},after={}};
			lineTable.line[1].txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viTotalStateOutput.clickTitleHelpTxt}};
		else
			table.insert(lineTable.line[1].txt[1].icon.before, 1, {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=viTotalStateOutput.clickTitleHelpTxt}});
		end;
	end;
	--help icon--
	viTotalStateOutput.output = lineTable;
end;

function viTotalStateOutput:loadFixLines()
	local lineTable = {line={}};
	local isLineTable = nil;
	function setNoScrollLinesFix()
		for a=1, viTotalState.values.notScrollLines+1 do
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].txt = "";			
		end;		
	end;
	setNoScrollLinesFix();
	viTotalStateOutput.outputFixLines = lineTable;
end;

function viTotalStateOutput.giveOutputTableFixLines(args)
	if args == nil or type(args) ~= "table" then return false;end;
	viTotalStateOutput:loadFixLines();
	return viTotalStateOutput.outputFixLines;
end;	

function viTotalStateOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	g_currentMission.multiOverlayV4.moduleFunction.setActiveRunningModul( {modName="vehicleInspector", modulName="viTotalState" } );	
	if args.slotTable.viSetNotScroll == nil then viTotalStateOutput.checkNotScroll(args.slotTable, nil);end;
	VehicleInspector.global.isCmdActive.viTotalState = true;
	viTotalStateOutput:load(args.slotTable);
	return viTotalStateOutput.output;
end;

function viTotalStateOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.titel = "VehicleInspector";
		VehicleInspector.moh.moSetGetOverlays.infoHelpBox.help.txt = "Click Icons or Vehicles for more Info/Sort and ... (Mouse Click Left/Right/Middle)\nJoin/Teleport a Vehicle/Position only over Teleport Icon and Vehicle is Selected";
	end;
end;

function viTotalStateOutput.clickSelectVehicle(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then		
		if args.ownTable[1] == viTotalState.values.selectVehicle then
			viTotalState.values.selectVehicle = 0;
		else
			viTotalState.values.selectVehicle = args.ownTable[1];
		end;
	end;
end;

function viTotalStateOutput.clickControlledIcon(args) --join vehicle
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			args.rootNode = args.ownTable[1];
			viSetGet:clickVehicleJoin(args);
		end;
	end;
end;

function viTotalStateOutput.clickTeleportIcon(args) --teleport vehicle position
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local isJoinVehicle = false; --viSetGet:clickVehicleJoin({rootNode=args.ownTable[1]});
			if isJoinVehicle ~= nil and not isJoinVehicle then
				local vehicle = g_currentMission.nodeToObject[args.ownTable[1]];
				if vehicle == nil or vehicle.steeringAxleNode == nil then g_currentMission.hl.addTextDisplay( {txt="Can not Join/Teleport in Vehicle !!", txtBold=true, duration=2, warning=true} );return;end;
				local vPosX, vPosY, vPosZ = getWorldTranslation(vehicle.steeringAxleNode);
				g_currentMission.player:moveToAbsolute(vPosX, vPosY, vPosZ+2, false, false);
			end;
		end;
	end;
end;

function viTotalStateOutput.clickSortBy(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		function setDefaultSortBy()
			viTotalState.values.sortBy.typ = "low";
			viTotalState.values.sortBy.what = "fullName";
		end;
		if args.ownTable[1] == "sortByString" then
			if args.ownTable[2] == "name" then
				if viTotalState.values.sortBy.what == "fullName" then
					viTotalState.values.sortBy.what = "typeDescName";
				elseif viTotalState.values.sortBy.what == "typeDescName" then			
					viTotalState.values.sortBy.what = "viCategoryName";
				else	
					viTotalState.values.sortBy.what = "fullName";
				end;
			end;
			viTotalState.values.sortBy.typ = "low";
		elseif args.ownTable[1] == "sortByInt" then			
			if args.ownTable[2] == viTotalState.values.sortBy.what then
				setDefaultSortBy();
			else
				viTotalState.values.sortBy.what = args.ownTable[2];
				viTotalState.values.sortBy.typ = args.ownTable[3];
			end;					
		elseif args.ownTable[1] == "sortByBol" then			
			if args.ownTable[2] == viTotalState.values.sortBy.what then
				setDefaultSortBy();
			else
				viTotalState.values.sortBy.what = args.ownTable[2];
				viTotalState.values.sortBy.typ = args.ownTable[3];
			end;
		end;		
		viTotalState:loadAllState(); --sortBy change
	end;
end;

function viTotalStateOutput.clickViewOther(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		local viewWhat = args.ownTable[2];
		if viewWhat ~= nil and viTotalState.values.viewOther[viewWhat] ~= nil then
			viTotalState.values.viewOther[viewWhat] = not viTotalState.values.viewOther[viewWhat];
			if viewWhat == "maxWorkingSpeed" then
				if viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "maxSpeed" then 
					viTotalState.values.sortBy.what = "maxWorkingSpeed";
				elseif not viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "maxWorkingSpeed" then
					viTotalState.values.sortBy.what = "maxSpeed";
				end;
				viTotalState:loadAllState(); --sortBy change
			elseif viewWhat == "refuel" then
				if viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "fuel" then 
					viTotalState.values.sortBy.what = "refuel";
				elseif not viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "refuel" then
					viTotalState.values.sortBy.what = "fuel";
				end;
				viTotalState:loadAllState(); --sortBy change
			elseif viewWhat == "updatePs" then
				if viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "ps" then 
					viTotalState.values.sortBy.what = "updatePs";
				elseif not viTotalState.values.viewOther[viewWhat] and viTotalState.values.sortBy.what == "updatePs" then
					viTotalState.values.sortBy.what = "ps";
				end;
				viTotalState:loadAllState(); --sortBy change
			end;
		end;
	end;
end;		

function viTotalStateOutput.clickViewState(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		local viewWhat = args.ownTable[1];
		function setDefaultSortBy()
			viTotalState.values.sortBy.typ = "low";
			viTotalState.values.sortBy.what = "fullName";
		end;
		if viewWhat ~= nil and viTotalState.values.view[viewWhat] ~= nil then			
			viTotalState.values.view[viewWhat] = not viTotalState.values.view[viewWhat];
			if viewWhat ~= "all" then viTotalState.values.view["all"] = false;end;
			if not viTotalState.values.view[viewWhat] and viTotalState.values.sortBy.what == viewWhat then				
				setDefaultSortBy();			
			end;		
		end;
	end;
end;

function viTotalStateOutput.clickViewTyp(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		local viewTyp = args.ownTable[1];
		if viewTyp ~= nil and viTotalState.values.viewTyp[viewTyp] ~= nil then
			function setDefaultSortBy()
				viTotalState.values.sortBy.typ = "low";
				viTotalState.values.sortBy.what = "fullName";
				viTotalState.values.selectVehicle = 0;
				viTotalState:loadAllState(); --sortBy change
			end;
			viTotalState.values.viewTyp[viewTyp] = not viTotalState.values.viewTyp[viewTyp];
			if viewWhat ~= "all" then viTotalState.values.view["all"] = false;end;
			if not viTotalState.values.viewTyp[viewTyp] then setDefaultSortBy();end;			
		end;
	end;
end;

function viTotalStateOutput.clickTitle(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageGarageOverview ~= nil then
			g_gui:showGui("InGameMenu");
			g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageGarageOverview, true);
		end;
	end;
end;

function viTotalStateOutput.checkNotScroll(slotTable, orgCmd) --in MOH scroll for 4x lines (title Text,totalSell... and Title Icons) disabled
	if slotTable == nil then return;end;	
	if slotTable.viSetNotScroll == nil then
		if orgCmd == nil then
			slotTable.viSetNotScroll = true;
			slotTable.maxNotScrollLine = slotTable.maxNotScrollLine+viTotalState.values.notScrollLines;
		elseif slotTable.viSetNotScroll then
			slotTable.viSetNotScroll = nil;
			if slotTable.maxNotScrollLine >= viTotalState.values.notScrollLines then slotTable.maxNotScrollLine = slotTable.maxNotScrollLine-viTotalState.values.notScrollLines;end;
		end;
	end;
end;
if g_currentMission.multiOverlayV4 ~= nil then
	g_currentMission.multiOverlayV4.moduleFunction.addActiveRunningModul( {modName="vehicleInspector", modulName="viTotalState" } );
end;